#TEMPLATE (CF_Func,'LSi Copy File Function')
#PROCEDURE(CopyFileFunc,'Function to copy files')
#BOXED('')
  #DISPLAY('This function uses four parameters')
  #DISPLAY('1) Full SOURCE path and filename (wild cards OK)')
  #DISPLAY('2) Full TARGET path (NO filename, NO wild cards)')
  #DISPLAY('3) Progress Window: 1=DISPLAY 0=HIDE')
  #DISPLAY('4) TARGET extension if changed')
  #DISPLAY('    (no wild cards, max 3 chrs, may be omitted)')
  #BOXED(' PLEASE NOTE ')
    #DISPLAY('* RETURNS 0 IF SUCCESSFUL')
    #DISPLAY('* Returns -1 on source path error')
    #DISPLAY('* Returns -2 on target path error')
    #DISPLAY('* Or the appropriate errorcode()')
    #DISPLAY('* Target paths WILL BE CREATED if path')
    #DISPLAY('    provided is a legal DOS path')
    #DISPLAY('* There is no error checking for correct')
    #DISPLAY('    use of wild cards in SOURCE path')
  #ENDBOXED
  #BUTTON('Disclaimer/Examples')
    #BOXED(' DISCLAIMER ')
      #DISPLAY('Provided as is. No warranty implied.')
      #DISPLAY('No usefulness for particular purpose implied')
      #DISPLAY('Use this software at your own risk.')
      #DISPLAY('LSi accepts no responsibility for its use.')
      #DISPLAY('...... but it DOES work!')
    #ENDBOXED
    #DISPLAY('')
    #BOXED(' EXAMPLE ')
      #DISPLAY('SOURCE: c:\dos\*.COM')
      #DISPLAY('TARGET: d:\newdir')
      #DISPLAY('DISPLAY: 1')
      #DISPLAY('NEWEXT: CCC')
      #DISPLAY('module(source path\file,target path,display[,newext])')
      #DISPLAY('    "newext" (new extension) may be omitted')
      #DISPLAY('')
      #DISPLAY('ERR#=CopyFiles(''c:\dos\*.COM'',''d:\newdir'',1,''CCC'')')
      #DISPLAY('Assuming you named this module "CopyFiles"')
      #DISPLAY('Copies all *.COM files from c:\dos into')
      #DISPLAY('d:\newdir and changes the extension to *.CCC')
      #DISPLAY('and displays progress while copying files.')
      #DISPLAY('(creates d:\newdir if not found)')
    #ENDBOXED
  #ENDBUTTON
#ENDBOXED

SourceFileName      CSTRING(81)

  MAP
    MODULE('')
      fcFindFirst(*CSTRING,*STRING,SHORT),SHORT,RAW,NAME('_findfirst')
      fcFindNext(*STRING),SHORT,RAW,NAME('_findnext')
      fcAccess(*CSTRING,SHORT),SHORT,RAW,NAME('_access')
      fcMkDir(*CSTRING),SHORT,RAW,NAME('_mkdir')
    END
  END

%Procedure FUNCTION(SourceFile,TargetPath,ShowProgress,NewExtension)
  #PROTOTYPE('(STRING,STRING,BYTE,<<STRING>),LONG')
  #PROJECT('CWDOS.LIB')

FileInfo      GROUP
                BYTE,DIM(21)
Attributes      BYTE
TimeStamp       SHORT
DateStamp       SHORT
Filesize        LONG
FileName        CSTRING(13)
              END

sPath         CSTRING(81)
sFile         CSTRING(81)
tFile         CSTRING(81)
tPath         CSTRING(81)
Temp_tPath    CSTRING(81)

FileQueue     QUEUE,PRE(FQ)
sFileName       STRING(12)
              END

FileSource    FILE,DRIVER('DOS'),NAME(SourceFileName)
RECORD          RECORD
DATA              BYTE
                END
              END

Window WINDOW,AT(,,240,56),FONT('Arial',8,,FONT:bold),CENTER,GRAY,DOUBLE
       BOX,AT(13,17,214,22),COLOR(00H),FILL(0FFFFFFH)
       STRING('Copying  Files'),AT(97,5,,10),TRN,CENTER
       BOX,AT(18,21,204,14),COLOR(00H),FILL(0C0C0C0H)
       BOX,AT(20,23,9,10),USE(?FILE0),COLOR(080H),FILL(080H)
       BOX,AT(30,23,9,10),USE(?FILE1),COLOR(080H),FILL(080H)
       BOX,AT(40,23,9,10),USE(?FILE2),COLOR(080H),FILL(080H)
       BOX,AT(50,23,9,10),USE(?FILE3),COLOR(080H),FILL(080H)
       BOX,AT(60,23,9,10),USE(?FILE4),COLOR(080H),FILL(080H)
       BOX,AT(70,23,9,10),USE(?FILE5),COLOR(080H),FILL(080H)
       BOX,AT(80,23,9,10),USE(?FILE6),COLOR(080H),FILL(080H)
       BOX,AT(90,23,9,10),USE(?FILE7),COLOR(080H),FILL(080H)
       BOX,AT(100,23,9,10),USE(?FILE8),COLOR(080H),FILL(080H)
       BOX,AT(110,23,9,10),USE(?FILE9),COLOR(080H),FILL(080H)
       BOX,AT(120,23,9,10),USE(?FILE10),COLOR(080H),FILL(080H)
       BOX,AT(130,23,9,10),USE(?FILE11),COLOR(080H),FILL(080H)
       BOX,AT(140,23,9,10),USE(?FILE12),COLOR(080H),FILL(080H)
       BOX,AT(150,23,9,10),USE(?FILE13),COLOR(080H),FILL(080H)
       BOX,AT(160,23,9,10),USE(?FILE14),COLOR(080H),FILL(080H)
       BOX,AT(170,23,9,10),USE(?FILE15),COLOR(080H),FILL(080H)
       BOX,AT(180,23,9,10),USE(?FILE16),COLOR(080H),FILL(080H)
       BOX,AT(190,23,9,10),USE(?FILE17),COLOR(080H),FILL(080H)
       BOX,AT(200,23,9,10),USE(?FILE18),COLOR(080H),FILL(080H)
       BOX,AT(210,23,9,10),USE(?FILE19),COLOR(080H),FILL(080H)
     END

  CODE
  DO Parse_sPath
  sFile = SourceFile

  IF SUB(CLIP(TargetPath),-1,1)='\'
    TargetPath = SUB(CLIP(TargetPath),1,LEN(CLIP(TargetPath))-1)
  END
  tPath = TargetPath

  !Check for existance of target directory
  IF fcFindFirst(tPath,FileInfo,10H) <> 0
    DO MAKE_DIR
  END

  !Find first matching file
  IF fcFindFirst(sFile,FileInfo,00H) <> 0
    RETURN(2)                               !<== file not found
  END

  FREE(FileQueue)
  CLEAR(FileQueue)

  FQ:sFileName = Filename
  ADD(FileQueue)

  LOOP
    IF fcFindNext(FileInfo) <> 0 THEN BREAK.
    FQ:sFileName = Filename
    ADD(FileQueue)
  END

  IF ShowProgress
    OPEN(Window)
    HIDE(?FILE0,?FILE19)
    ACCEPT
      BREAK
    END
  END
  LOOP REC#=1 TO RECORDS(FileQueue)
    GET(FileQueue,REC#)
    SourceFileName = CLIP(sPath)&FQ:sFileName
    IF OMITTED(3) OR ~NewExtension
      tFile = CLIP(TargetPath)&'\'&CLIP(FQ:sFileName)
    ELSE
      POS#=INSTRING('.',FQ:sFileName,1)
      IF POS#
        tFile = CLIP(TargetPath)&'\'&SUB(FQ:sFileName,1,POS#)&NewExtension
      ELSE
        tFile = CLIP(TargetPath)&'\'&CLIP(FQ:sFileName)&'.'&NewExtension
      END
    END
    IF fcAccess(SourceFileName,6)
      RETURN(5)                             !<== access denied for read/write
    END
    COPY(FileSource,tFile)
    IF ERRORCODE()
      RETURN(ERRORCODE())
    END
    IF ~ShowProgress THEN CYCLE.
    UNHIDE(?FILE0,?FILE0+(20*(REC#/RECORDS(FileQueue)))-1)
    DISPLAY
  END
  IF ShowProgress
    CLOSE(Window)
  END
  RETURN(0)

Parse_sPath ROUTINE
  sPath = ''
  POS# = INSTRING('\',SourceFile,1)
  LOOP WHILE POS#
    NEWPOS# = INSTRING('\',SourceFile,1,POS#+1)
    IF ~NEWPOS# THEN BREAK.
    POS# = NEWPOS#
  END
  sPath = SUB(SourceFile,1,POS#-1)
  IF ~sPath OR fcFindFirst(sPath,FileInfo,10H) <> 0
    RETURN(-1)                              !<== error in source path
  END
  sPath = SUB(SourceFile,1,POS#)
  EXIT

Make_Dir ROUTINE
  POS# = INSTRING('\',tPath,1,1)
  LOOP
    POS# = INSTRING('\',tPath,1,POS#+1)
    Temp_tPath = SUB(tPath,1,POS#-1)
    !Check for existance of directory
    IF fcFindFirst(Temp_tPath,FileInfo,10H) <> 0
      IF fcMkDir(Temp_tPath) <> 0
        RETURN(-2)                          !<== unable to create path
      END
    END
    IF ~POS# THEN BREAK.
  END
  IF fcFindFirst(tPath,FileInfo,10H) <> 0
    RETURN(-2)                              !<== unable to create/locate path
  END
  EXIT

